<template>
  <div class="navbar" :class="{ 'is-hide': !hideTop, 'is-sticky': sticky }">
    <div class="navbar__container">
      <div class="navbar__left">
        <slot name="left"></slot>
      </div>
      <nuxt-link class="navbar__logo" :to="localePath('/')">
        <svg-icon name="logotype-small" />
      </nuxt-link>
      <div class="navbar__right">
        <slot name="right"></slot>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  onMounted,
  onBeforeUnmount,
  ref,
  useContext
} from '@nuxtjs/composition-api'

import BurgerNav from '@/components/ui/BurgerNav.vue'
import Avatar from '@/components/ui/Avatar.vue'
export default defineComponent({
  name: 'NavBar',
  components: { BurgerNav, Avatar },
  setup(_, { root }) {
    const { app } = useContext()
    const OFFSET = 100
    const sticky = ref(false)
    const hideTop = ref(true)
    const lastScrollPosition = ref(0)
    const onScroll = () => {
      if (window.pageYOffset < 0) {
        return
      }
      if (Math.abs(window.pageYOffset - lastScrollPosition.value) < OFFSET) {
        return
      }
      hideTop.value = window.pageYOffset < lastScrollPosition.value
      sticky.value = lastScrollPosition.value > 200
      lastScrollPosition.value = window.pageYOffset
    }

    onMounted(() => {
      window.addEventListener('scroll', onScroll)
    })

    onBeforeUnmount(() => {
      window.removeEventListener('scroll', onScroll)
    })

    return {
      hideTop,
      sticky
    }
  }
})
</script>

<style lang="scss" scoped>
.navbar {
  background: #1f232f;
  border-bottom: 1px solid #272c3b;
  position: fixed;
  left: 0px;
  right: 0px;
  top: 0px;
  z-index: 9;

  transform: translate3d(0, 0, 0);
  transition: 550ms all ease-out;
  $self: &;

  &.no-bg {
    @media (min-width: 991.98px) {
      background: 0;
      border-bottom: 0;
      &.is-sticky {
        background: #1f232f;
      }
    }
  }
  &.is-hide {
    transform: translate3d(0, -100%, 0);
    #{$self}__logo {
      opacity: 1;
    }
  }
  &.is-sticky {
    #{$self}__logo {
      opacity: 1;
    }
  }
  &__container {
    height: 55px;
    margin: 0 auto;
    padding: 0 15px;
    display: flex;
    align-items: center;
    justify-content: space-between;
    @media (min-width: 991.98px) {
      max-width: 1920px;
      height: 85px;
    }
  }
  &__left {
    display: flex;
    align-items: center;
    flex: 1;
  }
  &__right {
    display: flex;
    align-items: center;
    justify-content: flex-end;
    flex: 1;
    > * {
      margin-right: 10px;
      flex: none;
      @media (min-width: 991.98px) {
        margin-right: 20px;
      }
      &:last-child {
        margin-right: 0px;
      }
    }
  }
  &__logo {
    flex: none;
    // opacity: 0;
    transition: 150ms all;
    svg {
      display: block;
      margin: 0 auto;
      width: 35px;
      height: 35px;
      fill: #fff;

      @media (min-width: 991.98px) {
        width: 45px;
        height: 45px;
      }
    }
  }
  &__search {
    margin: -5px 0;
    flex: 1;
    > input {
      border: 0;
      outline: none;
      padding: 15px;
      height: 55px;
      color: #fff;
      font-size: 18px;
      font-weight: 500;
      width: 100%;
      height: 50px;
      background: 0;
      @media (min-width: 991.98px) {
        padding: 15px 25px;
        background: #384057;
        border-radius: 80px;
        width: 300px;
        height: 55px;
        font-size: 20px;
        line-height: 25px;
      }
      &::placeholder {
        color: #fff;
      }
    }
    @media (min-width: 991.98px) {
      margin: 0 0 0 20px;
    }
  }
  &__avatar {
    height: 40px;
    width: 40px;
    flex: none;
    @media (min-width: 991.98px) {
      height: 60px;
      width: 60px;
    }
    &::v-deep {
      > * {
        width: 100%;
        height: 100%;
      }
    }
  }
  &__links {
    background: 0;
    border-radius: 7px;
    display: flex;
    align-items: center;
    height: 40px;
    font-size: 0px;
    cursor: pointer;
    @media (min-width: 991.98px) {
      padding: 15px 25px;
      height: 60px;
      background: #384057;
      &.is-active {
        background: #0065ff;
      }
    }
    span {
      color: #fff;
      font-size: 20px;
      line-height: 25px;
      font-weight: 500;
      margin-right: 15px;
      &:last-child {
        margin-right: 0px;
        margin-left: 10px;
      }
      @media (max-width: 991.98px) {
        display: none;
      }
    }
    &::v-deep {
      svg {
        width: 20px;
        height: 20px;
        fill: rgba(#fff, 0.4);
        @media (min-width: 991.98px) {
          width: 22px;
          height: 22px;
        }
      }
    }
  }
  &__tabs {
    display: flex;
    @media (min-width: 991.98px) {
      background: #384057;
      border-radius: 7px;
    }
    #{$self}__links {
      @media (max-width: 991.98px) {
        &.is-active {
          display: none;
        }
      }
    }
  }
  &__ul {
    ul {
      display: flex;
      align-items: center;
      margin: 0px;
      padding: 0px;
      list-style: none;
      li {
        margin-right: 30px;
        a {
          color: #9badd6;
          font-size: 24px;
          line-height: 30px;
          font-weight: 500;
          text-decoration: none;
          &.is-active {
            color: #fff;
          }
        }
      }
    }
  }
}
</style>
